#include <stdbool.h>
#include <string.h>

bool isDigit(char c)
{
  return c >= '0' && c <= '9';
}

bool checkPhoneNumber(char text[])
{
  int textLength = strlen(text);
  
  if(text[0] != '0')
  {
    return false;
  }
  
  // Also steht vorne eine Null.
  
  // a
  if(textLength < 2 || !isDigit(text[1]) || text[1] == '0')
  {
    return false;
  }

  // b
  if(textLength < 3 || !isDigit(text[2]))
  {
    return false;
  }  
  
  int i = 0;
  // c
  if(textLength < 4)
  {
    return false;
  }
  if(text[3] == '/')
  {
    i = 4;
  }
  else if(!isDigit(text[3]))
  {
    return false;
  }
  else // Wir haben eine Ziffer!
  {
    // d
    if(textLength < 5)
    {
      return false;
    }    
    if(text[4] == '/')
    {
      i = 5;
    }
    else if(!isDigit(text[4]))
    {
      return false;
    }
    else // Wir haben eine Ziffer!
    {
      if(textLength < 6)
      {
        return false;
      }      
      if(text[5] == '/')
      {
        i = 6;
      }
      else
      {
        return false;
      }
    }    
  }
 
  // e
  if(textLength < i+1 || !isDigit(text[i]) || text[i] == '0')
  {
    return false;
  }  
  
  // f bis i
  for(int j = 0; j < 4; j++)
  {
    i++;
    if(textLength < i+1 || !isDigit(text[i]))
    {
      return false;
    }
  }

  // j bis l
  for(int j = 0; j < 3; j++)
  {
    i++;
    if(text[i] == '\0')
    {
      return true;
    }    
    if(!isDigit(text[i]))
    {
      return false;
    }
  }
  
  i++;
  if(text[i] == '\0')
  {
    return true;
  }   
  return false;
}

int main( void )
{
  bool r = checkPhoneNumber("0123/3456789");
  r = checkPhoneNumber("012a/3456789");
  r = checkPhoneNumber("0123/345678923422");
  r = checkPhoneNumber("0123/03456789");
  return 0;
}
